<template>
  <div class="create-pass">
    <h2 class="title">Create new password</h2>
    <div class="desc">
      Please, create new password for your account.
    </div>
    <form class="create-pass__form" @submit.prevent="createPass">

      <!-- pass -->
      <v-input  name="Password"
                :type="typePassword"
                v-model="user.password"
                @change="updateUserPassword"
                :isError="$v.user.password.$error">
        <template slot="optional">
          <button class="btn btn--empty" type="button" name="showPass" @click="showPass = !showPass">
            <img width="20" src="@/assets/img/svg/eye.svg" alt="eye" v-if="showPass">
            <img width="20" src="@/assets/img/svg/hide.svg" alt="eye" v-else>
          </button>
        </template>
        <template slot="error">
          <div class="error" v-if="!$v.user.password.required">Field is required</div>
        </template>
      </v-input>

      <!-- password meter -->
      <password-meter :pass="user.password"/>

      <!-- confirm pass -->
      <v-input  name="Confirm password"
                :type="typePassword"
                v-model="user.confirmPassword"
                @change="updateUserConfirmPassword"
                :isError="$v.user.confirmPassword.$error">
        <template slot="optional">
          <button class="btn btn--empty" type="button" name="showPass" @click="showPass = !showPass">
            <img width="20" src="@/assets/img/svg/eye.svg" alt="eye" v-if="showPass">
            <img width="20" src="@/assets/img/svg/hide.svg" alt="eye" v-else>
          </button>
        </template>
        <template slot="error">
          <div class="error" v-if="!$v.user.confirmPassword.required">Field is required</div>
        </template>
      </v-input>

      <!-- button -->
      <button class="btn" type="submit" name="Set new password">
          Set new password
      </button>
    </form>
  </div>
</template>

<script>
import Input from '@/components/Input';
import PasswordMeter from '@/components/Authorization/PasswordMeter';
import call from '@/services/callService';
import {mapMutations} from 'vuex';
import {helpers, required, sameAs, minLength, maxLength} from 'vuelidate/lib/validators';
const touchMap = new WeakMap();

// Get Password Policy
let regExPass = helpers.regex('alpha', /(?=.*\d+)(?=.*[A-Za-z]+).{8,20}/);
(async () => {
  let result = await call.getPasswordPolicy();
  if (result) {
    (regExPass === helpers.regex('alpha', new RegExp(result.regularExpression))) ? 0 : regExPass = helpers.regex('alpha', new RegExp(result.regularExpression))
  }
})();

export default {
  name: 'CreatePass',
  data() {
    return {
      user: {
        password: '',
        confirmPassword: '',
      },
      showPass: false,
    }
  },
  validations: {
    user: {
      password: {
        required,
        minLength: minLength(8),
        maxLength: maxLength(20),
        regExPass
      },
      confirmPassword: {
        sameAsPassword: sameAs('password')
      }
    }
  },
  components:{
    'v-input': Input,
    PasswordMeter
  },
  methods: {
    ...mapMutations(['UPDATE_AUTH_COMPONENT']),
    updateUserPassword(val) {
      this.delayTouch(this.$v.user.password);
      this.user.password = val;
    },
    updateUserConfirmPassword(val) {
      this.delayTouch(this.$v.user.confirmPassword);
      this.user.confirmPassword = val;
    },
    async resetPass(params) {
      await call.resetPassword(params);
    },
    createPass() {
      let disabled = false;
      this.$v.user.password.$touch();
      this.$v.user.confirmPassword.$touch();
      if (this.$v.user.password.$error || this.$v.user.confirmPassword.$error ) {
        return 0;
      }
      const params = {
        "key": this.getKey,
        "password": this.user.password
      };
      if (!disabled) {
        disabled = true;
        this.resetPass(params)
          .then((result)=>{
            console.log('New password successfully created', result);
            this.$notify({
              group: 'app',
              type:'success',
              text: 'New password successfully created'
            });
            this.goToLogin();
            this.$router.push('/');
          })
          .catch((err) => {
            const message = err.desc || JSON.stringify(err);
            this.$notify({
              group: 'app',
              type:'success',
              text: message
            });
            console.error(`EM Create New Password Error: ${message}`);
          })
          .finally(() => {
            disabled = false;
          });
      }
    },
    goToLogin() {
      this.UPDATE_AUTH_COMPONENT({name: 'log', isShown: true});
    },
    delayTouch($v) {
      $v.$reset();
      if (touchMap.has($v)) {
        clearTimeout(touchMap.get($v));
      }
      touchMap.set($v, setTimeout($v.$touch, 1000));
    }
  },
  computed: {
    typePassword() {
      return (this.showPass) ? 'text' : 'password';
    },
    getKey() {
      return this.$route.params.id;
    }
  }
}
</script>

<style lang="sass" scoped>
.title
  font-family: $mainFont
  font-size: rem(32)
  line-height: 1.2
  margin: rem(70) 0 rem(18)
  text-align: left
.desc
  color: #636e7e
  font-family: $mainFont
  font-size: 1rem
  font-weight: 500
  line-height: 1.13
  text-align: left
  margin: 0 0 rem(58)
.create-pass
  &__form >
    margin-top: rem(50)
    .input
      margin-top: rem(36)
    .btn
      display: block
      margin: rem(30) auto 0 0
    .password-meter
      margin-top: rem(26)
</style>
